;====================================================================
.model small,c
.386
.stack
;====================================================================
.data
.code
;====================================================================

;--------------------------------------------------------------------
; The entry label is not actually necessary, but included along with
; a reference to it in the end directive to prevent the linker from
; returning a warning.
;--------------------------------------------------------------------

entry:

;------------------------------------------------------------------
; For convenience in calling the procedures from a separate module
; that cannot access the procedures by name, place a jump table at
; the start of the overlay code. The far pointers are 5 bytes each
; and the nops put the jumps at an even alignment and the table
; pitch at 6 bytes.
;------------------------------------------------------------------

jmp FAR PTR proc0
nop
jmp FAR PTR proc1
nop
jmp FAR PTR proc2
nop

proc0 proc FAR arg:DWORD
    mov eax, arg
    ret
proc0 endp

proc1 proc FAR arg:DWORD
    mov eax, arg
    add eax, 1
    ret
proc1 endp

proc2 proc FAR arg:DWORD
    mov eax, arg
    add eax, 2
    ret
proc2 endp

end entry

